using System;
using System.Drawing;

namespace SeaTracePredictor
{
	/// <summary>
	/// 
	/// </summary>
	public class PositionPredictorPie
	{
		//central point x
		private double longitude;
		public double Longitude
		{
			get
			{
				return longitude;
			}
		}

		//central point y
		private double latitude;
		public double Latitude
		{
			get
			{
				return latitude;
			}
		}

		//radius of the pie
		//in y there is radius
		//in x there is radius*(1/cos(phi))
		private double radiusX;
		public double RadiusX
		{
			get
			{
				return radiusX;
			}
		}

		//radius of the pie
		//in y there is radius
		//in x there is radius*(1/cos(phi))
		private double radiusY;
		public double RadiusY
		{
			get
			{
				return radiusY;
			}
		}

		//start angle of the pie
		private double startAngle;
		public double StartAngle
		{
			get
			{
				return startAngle;
			}
		}

		//sweep angle of the pie
		private double sweepAngle;
		public double SweepAngle
		{
			get
			{
				return sweepAngle;
			}
			set
			{
				this.sweepAngle = value;
			}
		}

		//constructor
		public PositionPredictorPie(double newLongitude, double newLatitude, double newRadiusX,
			double newRadiusY, double newStartAngle, double newSweepAngle)
		{
			this.longitude = newLongitude;
			this.latitude = newLatitude;
			this.radiusX = newRadiusX;
			this.radiusY = newRadiusY;
			this.startAngle = newStartAngle;
			this.sweepAngle = newSweepAngle;
		}

		public Rectangle GetPieRectangle(double longitudeP, double latitudeP, double maxRadiusXInSeconds, int matrixSize)
		{
			Rectangle result = new Rectangle();
			result.Width = (int)Math.Ceiling((radiusX/maxRadiusXInSeconds) * matrixSize);
			result.Height = (int)Math.Ceiling((radiusY/maxRadiusXInSeconds) * matrixSize);
			result.X = (int)Math.Round((((longitude - longitudeP)/(maxRadiusXInSeconds*2/(matrixSize))+(matrixSize)/2))  - (result.Width / 2));
			result.Y = (int)Math.Round((((latitude  - latitudeP)/(maxRadiusXInSeconds*2/(matrixSize))+(matrixSize)/2)) - (result.Height / 2));
			return result;
		}
	}
}
