using System;
using System.Collections;
using System.Drawing;

namespace SeaTracePredictor
{
	/// <summary>
	/// 
	/// </summary>
	public class PositionPredictorTriangle
	{
		private double longitude1;
		private double latitude1;
		private double longitude2;
		private double latitude2;
		private double longitude3;
		private double latitude3;

		public System.Drawing.Point[] GetTriangle()
		{
			System.Drawing.Point[] result = new Point[3];

			result[0].X = (int)Math.Round(longitude1);
			result[0].Y = (int)Math.Round(latitude1);
			result[1].X = (int)Math.Round(longitude2);
			result[1].Y = (int)Math.Round(latitude2);
			result[2].X = (int)Math.Round(longitude3);
			result[2].Y = (int)Math.Round(latitude3);

			return result;
		}

		public System.Drawing.Point[] GetTriangle(double longitude, double latitude, double maxRadiusXInSeconds, int matrixSize)
		{
			System.Drawing.Point[] result = new Point[3];

			result[0].X = (int)Math.Round(((longitude1-longitude)/(maxRadiusXInSeconds*2/(matrixSize))+(matrixSize)/2));
			result[0].Y = (int)Math.Round(((latitude1-latitude)/(maxRadiusXInSeconds*2/(matrixSize))+(matrixSize)/2)); 
			result[1].X = (int)Math.Round(((longitude2-longitude)/(maxRadiusXInSeconds*2/(matrixSize))+(matrixSize)/2));
			result[1].Y = (int)Math.Round(((latitude2-latitude)/(maxRadiusXInSeconds*2/(matrixSize))+(matrixSize)/2)); 
			result[2].X = (int)Math.Round(((longitude3-longitude)/(maxRadiusXInSeconds*2/(matrixSize))+(matrixSize)/2));
			result[2].Y = (int)Math.Round(((latitude3-latitude)/(maxRadiusXInSeconds*2/(matrixSize))+(matrixSize)/2)); 

			return result;
		}

		public System.Drawing.Point[] GetLineOnly(double longitude, double latitude, double maxRadiusXInSeconds, int matrixSize)
		{
			System.Drawing.Point[] result = new Point[2];

			result[0].X = (int)Math.Round(((longitude2-longitude)/(maxRadiusXInSeconds*2/(matrixSize))+(matrixSize)/2));
			result[0].Y = (int)Math.Round(((latitude2-latitude)/(maxRadiusXInSeconds*2/(matrixSize))+(matrixSize)/2)); 
			result[1].X = (int)Math.Round(((longitude3-longitude)/(maxRadiusXInSeconds*2/(matrixSize))+(matrixSize)/2));
			result[1].Y = (int)Math.Round(((latitude3-latitude)/(maxRadiusXInSeconds*2/(matrixSize))+(matrixSize)/2)); 

			return result;
		}

		public PositionPredictorTriangle(double newLongitude1, double newLatitude1,
			double newLongitude2, double newLatitude2, double newLongitude3, double newLatitude3)
		{
			this.longitude1 = newLongitude1;
			this.latitude1 = newLatitude1;
			this.longitude2 = newLongitude2;
			this.latitude2 = newLatitude2;
			this.longitude3 = newLongitude3;
			this.latitude3 = newLatitude3;
		}
	}
}
